// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_CORE_EVENT_H
#define FENNEC_TEST_CORE_EVENT_H

#include "../../test.h"
#include <fennec/core/event.h>

namespace fennec::test
{

struct test_event : public event {
	FENNEC_RTTI_CLASS_ENABLE(event) {
	}
};

struct test_listener : public event_listener {
	bool handled = { false };

	void handle_event(event* event) override {
		handled = true;
		fennec_test_run(event->get_type(), type::get<test_event>());
	}

	FENNEC_RTTI_CLASS_ENABLE(event_listener) {
	}
};

inline void fennec_test_core_event() {
	test_listener listener;
	event::add_listener<test_event>(&listener);

	event::dispatch<test_event>();
	event::handle_events();

	fennec_test_run(listener.handled, true);

	listener.handled = false;

	event::dispatch_immediate<test_event>();

	fennec_test_run(listener.handled, true);
}

}

#endif // FENNEC_TEST_CORE_EVENT_H
